/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2024. All rights reserved.
 */

#ifndef IMPL_TYPE_SWC2CAN_H
#define IMPL_TYPE_SWC2CAN_H

#include "impl_type_uint8.h"
#include "impl_type_uint64.h"

struct SWC2CAN {
    ::UInt8 signal{ 0U };
    ::UInt64 value{ 0U };

    static bool IsPlane()
    {
        return true;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(signal);
        fun(value);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(signal);
        fun(value);
    }

    template<typename F>
    void enumerate_internal(F& fun)
    {
        fun("signal", signal);
        fun("value", value);
    }

    template<typename F>
    void enumerate_internal(F& fun) const
    {
        fun("signal", signal);
        fun("value", value);
    }

    friend bool operator==(const ::SWC2CAN& lhs, const ::SWC2CAN& rhs) noexcept
    {
        return (lhs.signal == rhs.signal) && (lhs.value == rhs.value);
    }
};


#endif // IMPL_TYPE_SWC2CAN_H
